#include <stdio.h>
#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define MP(f, s) make_pair(f, s)
typedef vector< pair<int, int> > Plane;


Plane generatePlanForOneStudent(int d, int b, int isOneMore) {
  vector<int> freeBooks, usedBooks;
  freeBooks.reserve(b+1);
  usedBooks.reserve(b+1);
  const int prTaken = 50 + rand() % 20;
  const int prRet = rand() % 100;
  for (int i = 1; i <= b; i++) {
    freeBooks.push_back(i);
  }
  Plane result;
  result.reserve(d);
  
  for (int i = 0; i < d; i++) {
    int daysRemaining = d - i;
    int pr = rand() % 100;
    int retBook = 0;
    if (usedBooks.size() == daysRemaining || pr <= prRet && usedBooks.size()) {
      int s = usedBooks.size();
      int rn = rand() % s--;
      swap(usedBooks[rn], usedBooks[s]);
      retBook = usedBooks[s];
      usedBooks.pop_back();
      if (isOneMore) {
        freeBooks.push_back(retBook); 
      }
    }

    pr = rand() % 100;
    int takenBook = 0;
    if (usedBooks.size() < --daysRemaining && pr <= prTaken && freeBooks.size()) {
      int s = freeBooks.size();
      int tn = rand() % s--;
      swap(freeBooks[tn], freeBooks[s]);
      usedBooks.push_back(takenBook = freeBooks[s]); freeBooks.pop_back();
    }

    if (retBook == takenBook) {
      retBook = takenBook = 0;
    }
    result.push_back(MP(retBook, takenBook));
  }

  return result;
}


int main(int argc, char* argv[]) {
  int const p = atoi(argv[1]);
  int const d = atoi(argv[2]);
  int const b = atoi(argv[3]);
  int const randseed = atoi(argv[4]);
  int const isOneMore = atoi(argv[5]);

  srand(randseed);
  freopen("input.txt", "w", stdout);
  printf("%d %d\n", p, d);

  for (int i = 0; i < p; i++) {
    Plane curr = generatePlanForOneStudent(d, b, isOneMore);
    for (Plane::const_iterator it = curr.begin(); it < curr.end(); it++) {
      printf("%d %d  ", it->first, it->second);
    }
    printf("\n");
  }

  fclose(stdout);
  return 0;
}
